/*
 * libdevice-node
 *
 * Copyright (c) 2016 Samsung Electronics Co., Ltd.
 *
 * Licensed under the Apache License, Version 2.0 (the License);
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/*******************************************/
/* THIS IS THE HAL FOR EXPERIMENTAL USAGES */
/*******************************************/


#ifndef __HW_DISPLAY_INTERNAL_H__
#define __HW_DISPLAY_INTERNAL_H__

#include <hw/common.h>

/**
 * The id of this device
 */
#define DISPLAY_INTERNAL_HARDWARE_DEVICE_ID	"display_internal"

/**
 * The version of this device
 */
#define DISPLAY_INTERNAL_HARDWARE_DEVICE_VERSION	MAKE_VERSION(0,2)

typedef enum display_internal_enhance_mode {
	ENHANCE_MODE_NONE = 1001,
	ENHANCE_MODE_DYNAMIC,
	ENHANCE_MODE_STANDARD,
	ENHANCE_MODE_NATURAL,
	ENHANCE_MODE_GRAYSCALE,
	ENHANCE_MODE_MOVIE,
	ENHANCE_MODE_AUTO,
} display_internal_enhance_mode_e;

typedef enum display_internal_enhance_scenario {
	ENHANCE_SCENARIO_NONE = 2001,
	ENHANCE_SCENARIO_NORMAL,
	ENHANCE_SCENARIO_GALLERY,
	ENHANCE_SCENARIO_VIDEO,
	ENHANCE_SCENARIO_VTCALL,
	ENHANCE_SCENARIO_CAMERA,
	ENHANCE_SCENARIO_BROWSER,
	ENHANCE_SCENARIO_NEGATIVE,
	ENHANCE_SCENARIO_EMAIL,
	ENHANCE_SCENARIO_EBOOK,
	ENHANCE_SCENARIO_GRAYSCALE,
} display_intermal_enhance_scenario_e;

struct display_internal_device {
	struct hw_common common;

	int (*set_enhance_mode)(display_internal_enhance_mode_e mode);
	int (*get_enhance_mode)(display_internal_enhance_mode_e *mode);

	int (*set_enhance_scenario)(display_internal_enhance_scenario_e scenario);
	int (*get_enhance_scenario)(display_internal_enhance_scenario_e *scenario);

};

#endif
